/* ==== test_switch.c ============================================================
 * Copyright (c) 1993 by Chris Provenzano, proven@athena.mit.edu
 *
 * Description : Test context switch functionality.
 *
 *  1.00 93/08/04 proven
 *      -Started coding this file.
 */

#include <pthread.h>
#include <stdio.h>

#define OK      0
#define NOTOK  -1

buf = "abcdefghijklmnopqrstuvwxyz";
int fd = 1;

/* ==========================================================================
 * usage();
 */
void usage(void)
{
    printf("test_switch [-d?] [-c count]\n");
	printf("count must be between 2 and 26\n");
    errno = 0;
}

void* new_thread(void* arg)
{
	while(1) {
		write(fd, buf + arg, 1);
	}
	fprintf(stderr, "Compiler error\n");
	exit(1);
}

main(int argc, char **argv)
{
	pthread_t thread;
	int count = 2;
	int debug = 0;
	int i;

	char word[256];

    /* Getopt variables. */
    extern int optind, opterr;
    extern char *optarg;

	pthread_init();

	while ((word[0] = getopt(argc, argv, "c:d?")) != (char)EOF) {
		switch (word[0]) {
        case 'd':
            debug++;
            break;
        case 'c':
            count = atoi(optarg);
            if ((count > 26) || (count < 2)) {
				count = 2;
			}
            break;
        case '?':
            usage();
            return(OK);
        default:
            usage();
            return(NOTOK);
        }
    }
	

	for(i = 0; i < count; i++) {
		if (pthread_create(&thread, NULL, new_thread, i)) {
			printf("error creating new thread %d\n", i);
		}
	}
	pthread_exit(NULL);
	fprintf(stderr, "pthread_exit returned\n");
	exit(1);
}
